ModificationWatchpointRequest (Java SE 26 & JDK 26)
Description: declaration: module: jdk.jdi, package: com.sun.jdi.request, interface: ModificationWatchpointRequest
Keywords: com.sun.jdi.request.ModificationWatchpointRequest interface

# Interface ModificationWatchpointRequest

All Superinterfaces:
  `EventRequest, Mirror, WatchpointRequest`

public interface ModificationWatchpointRequest extends WatchpointRequest
Request for notification when a field is set. This event will be triggered when a value is assigned to the specified field with a Java programming language statement (assignment, increment, etc) or by a Java Native Interface (JNI) set function (`Set<Type>Field, SetStatic<Type>Field`). Setting a field to a value which is the same as the previous value still triggers this event. Modification by JDI does not trigger this event. When an enabled ModificationWatchpointRequest is satisfied, an `event set` containing a `ModificationWatchpointEvent` will be placed on the `EventQueue`. The collection of existing watchpoints is managed by the `EventRequestManager`.

Since:
  1.3
See Also:
  - `ModificationWatchpointEvent`
  - `AccessWatchpointRequest`
  - `EventQueue`
  - `EventRequestManager`

- ## Field Summary

  ### Fields declared in interface EventRequest

  `SUSPEND_ALL, SUSPEND_EVENT_THREAD, SUSPEND_NONE`
  Modifier and Type
  Field
  Description
  `static final int`
  `SUSPEND_ALL`
  Suspend all threads when the event occurs
  `static final int`
  `SUSPEND_EVENT_THREAD`
  Suspend only the thread which generated the event when the event occurs
  `static final int`
  `SUSPEND_NONE`
  Suspend no threads when the event occurs

- ## Method Summary

  ### Methods declared in interface EventRequest

  `addCountFilter, disable, enable, getProperty, isEnabled, putProperty, setEnabled, setSuspendPolicy, suspendPolicy`
  Modifier and Type
  Method
  Description
  `void`
  `addCountFilter(int count)`
  Limit the requested event to be reported at most once after a given number of occurrences.
  `void`
  `disable()`
  Same as `setEnabled(false)`.
  `void`
  `enable()`
  Same as `setEnabled(true)`.
  `Object`
  `getProperty(Object key)`
  Returns the value of the property with the specified key.
  `boolean`
  `isEnabled()`
  Determines if this event request is currently enabled.
  `void`
  `putProperty(Object key, Object value)`
  Add an arbitrary key/value "property" to this request.
  `void`
  `setEnabled(boolean val)`
  Enables or disables this event request.
  `void`
  `setSuspendPolicy(int policy)`
  Determines the threads to suspend when the requested event occurs in the target VM.
  `int`
  `suspendPolicy()`
  Returns a value which describes the threads to suspend when the requested event occurs in the target VM.

  ### Methods declared in interface Mirror

  `toString, virtualMachine`
  Modifier and Type
  Method
  Description
  `String`
  `toString()`
  Returns a String describing this mirror
  `VirtualMachine`
  `virtualMachine()`
  Gets the VirtualMachine to which this Mirror belongs.

  ### Methods declared in interface WatchpointRequest

  `addClassExclusionFilter, addClassFilter, addClassFilter, addInstanceFilter, addThreadFilter, field`
  Modifier and Type
  Method
  Description
  `void`
  `addClassExclusionFilter(String classPattern)`
  Restricts the events generated by this request to those whose location is in a class whose name does not match this restricted regular expression.
  `void`
  `addClassFilter(ReferenceType refType)`
  Restricts the events generated by this request to those whose location is in the given reference type or any of its subtypes.
  `void`
  `addClassFilter(String classPattern)`
  Restricts the events generated by this request to those whose location is in a class whose name matches a restricted regular expression.
  `void`
  `addInstanceFilter(ObjectReference instance)`
  Restricts the events generated by this request to those in which the currently executing instance ("this") is the object specified.
  `void`
  `addThreadFilter(ThreadReference thread)`
  Restricts the events generated by this request to those in the given thread.
  `Field`
  `field()`
  Gets the Field being watched by this WatchpointRequest.